/**** cnmrlib.h    */


#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <math.h>
#define MIN(x,y) (((x)<(y))?(x):(y))
#define MAX(x,y) (((x)>(y))?(x):(y))
#define NO       (-1)
#define YES      (1)
#define MAXLINE 1024

/*
#define  RESLIB_TAB_NAME "/prog/victor/c/nmr/tabs/ress0.tab"
#define  X_ALA_TAB_NAME  "/prog/victor/c/nmr/tabs/x_ala.tab"
#define  XALA__TAB_NAME  "/prog/victor/c/nmr/tabs/xala_.tab"
*/
#define  CS_REF_NAME    "calc_cs.rc"
#define _ALL_   0
#define _N_     1
#define _Hn_    2
#define _Ha_    3
#define _Hb_    4
#define _Hb2_   41
#define _Hb3_   42
#define _Hg_    5
#define _Hd_    6
#define _He_    7
#define _Hz_    8
#define _Hh_    9
#define _CO_    10
#define _Ca_    11
#define _Cb_    12
#define _Cg_    13
#define _Cd_    14
#define _Ce_    15
#define _Cz_    16
#define _AAVAL_ 99

#define _ALA_  ((int)'A'-(int)'A')
#define _ARG_  ((int)'R'-(int)'A')
#define _ASN_  ((int)'N'-(int)'A')
#define _ASP_  ((int)'D'-(int)'A')
#define _CYS_  ((int)'C'-(int)'A')
#define _GLN_  ((int)'Q'-(int)'A')
#define _GLU_  ((int)'E'-(int)'A')
#define _GLY_  ((int)'G'-(int)'A')
#define _HIS_  ((int)'H'-(int)'A')
#define _ILE_  ((int)'I'-(int)'A')
#define _LEU_  ((int)'L'-(int)'A')
#define _LYS_  ((int)'K'-(int)'A')
#define _MET_  ((int)'M'-(int)'A')
#define _PHE_  ((int)'F'-(int)'A')
#define _PRO_  ((int)'P'-(int)'A')
#define _SER_  ((int)'S'-(int)'A')
#define _THR_  ((int)'T'-(int)'A')
#define _TRP_  ((int)'W'-(int)'A')
#define _TYR_  ((int)'Y'-(int)'A')
#define _VAL_  ((int)'V'-(int)'A')
#define MAXBMRB_ITEMS 1600
typedef struct bmrb_item { int i,n; char rname3[5],aname[6],atype[3]; float cs; float err; int amb_code;
                         }  BMRB_ITEM ;
BMRB_ITEM bmrb_items[MAXBMRB_ITEMS],*pB,currentBMRBitem,*pBc; int nBMRBitems;
int printBMRBitem();

#define MAXRESDATA 300
typedef struct resdata_item { int i,n; char rname[4],name[8]; float f1,f2,f3,f4; } RESDATA_ITEM;
RESDATA_ITEM resdata[MAXRESDATA],*pRD; int nresdata;

#define MAXSTATNAMES 50
typedef struct name_num_item { int i; char name[16]; } NAME_NUM_ITEM;
NAME_NUM_ITEM statnames[MAXSTATNAMES]; int nstatnames;


#define MAXRTAB25 30
#define MAXANAMES 128
typedef struct reslib_tab25_item { int i; char rname3[5],rname1[3]; 
                                   char anames[MAXANAMES];  
                                   char acs   [MAXANAMES*2];  
                                 }  RESLIB_TAB25;
RESLIB_TAB25 rtab25[MAXRTAB25],*prt25,rtab25n[MAXRTAB25],*prt25n; static int nrtab25=0;
RESLIB_TAB25 *get_restab25_item();

#define MAXANAME 5
#define MAXRNAME 7
#define MAXRTAB 30
#define RESLIB_TAB_N  8
typedef struct reslib_tab_item /* tab20 */ 
                                 { int i; char rname3[5],rname1[3];  float pKR;
                                 char Type[3],RQatom[5]; float Afree; int Natoms;
				 float aaval;
                                 }  RESLIB_TAB;
RESLIB_TAB rtab[MAXRTAB],*prtab; static int nrtab=0;
RESLIB_TAB *get_restab_item();
/*FILE *frtab;*/
int get_rname3i();
int get_rname1i();

#define MAXRESLINEITEMS 31
typedef struct res_line_item  {  char rname3[6],rname1[3]; int n; int ncols; 
                                 char colname[MAXRESLINEITEMS][8],aname[MAXRESLINEITEMS][8];  
                                 int  d[MAXRESLINEITEMS];  
                                 float cs[MAXRESLINEITEMS]; 
                              } RES_LINE_ITEM; 
typedef struct x_ala_tab_item {  int i; char rname3[5],rname1[3]; char type[5];
                                 float N,Hn,Ha,Hb2,Hb3,CO,Ca,Cb,Hg12,Hg13,Hg2,Hd1,Hd2,He1,He2,Hz1,Hz2,Hh;
                              } X_ALA_TAB;
typedef struct xala__tab_item {  int i; char rname3[5],rname1[3]; char type[5];
                                 float N,Hn,Ha,Hb2,Hb3,CO,Ca,Cb;
                                 float dN,dHn,dHa,dHb2,dHb3,dCO,dCa,dCb;
                              } XALA__TAB;
#define GLYPOSTAB 6
X_ALA_TAB x_ala[MAXRTAB]; static int nx_ala=0;
X_ALA_TAB *get_x_ala_item();
XALA__TAB xala_[MAXRTAB]; static int nxala_=0;
XALA__TAB *get_xala__item();

#define CS_REF_SHIFTS   'r'
#define CS_EXPER_SHIFTS 'x'
#define CS_ERROR_SHIFTS 'e'
XALA__TAB cs_ref_shifts;
XALA__TAB cs_exper_shifts;
XALA__TAB cs_error_shifts;

typedef struct seq_item { /*res code*/int i; /*res num*/int n;  char rname3[5],rname1[3];  char string[16];
                        } SEQ;
#define MAXSEQ 500
SEQ seq[MAXSEQ]; static int nseq=0;

FILE* Fopen();
char *strupper();
char *strlower();
int  init_cnmrlib();
int  close_cnmrlib();
char *get_abbr_aname();
float get_atom_shift();
int get_ambiguity_code();
char* get_abbrev_aname();
char* get_better_aname();
float get_rcoil_val25();

FILE *errout;
char line [MAXLINE];
char str  [MAXLINE];
char strx [MAXLINE];
char stra [MAXLINE];

#define NBUFS 32
#define NCOMMENTS 6
char *buf[NBUFS];
char *tab[NBUFS];
char *tax[NBUFS];
char *col[NBUFS];
char *comments[NCOMMENTS];
char cs_ref_line[MAXLINE];


/**** EOF  cnmrlib.h    */
